# org.pdfclown.documents.contents.composition.BlockComposer Class Reference

Content block composer.It provides content positioning functionalities for page typesetting. More...

List of all members.

## Classes
class | ContentPlaceholder
class | Row
class | RowObject
## Public Member Functions
void | Begin (RectangleF frame, XAlignmentEnum xAlignment, YAlignmentEnum yAlignment)
| Begins a content block.
| BlockComposer (PrimitiveComposer baseComposer)
void | End ()
| Ends the content block.
void | ShowBreak (SizeF offset, XAlignmentEnum xAlignment)
| Ends current paragraph, specifying the offset and alignment of the next one.
void | ShowBreak (XAlignmentEnum xAlignment)
| Ends current paragraph, specifying the alignment of the next one.
void | ShowBreak (SizeF offset)
| Ends current paragraph, specifying the offset of the next one.
void | ShowBreak ()
| Ends current paragraph.
int | ShowText (string text, object lineAlignment)
| Shows text.
int | ShowText (string text)
| Shows text.
bool | ShowXObject (xObjects::XObject xObject, SizeF?size, object lineAlignment)
| Shows the specified external object.
bool | ShowXObject (xObjects::XObject xObject, SizeF?size)
| Shows the specified external object.
## Properties
PrimitiveComposer | BaseComposer`[get]`
| Gets the base composer.
RectangleF | BoundBox`[get]`
| Gets the area occupied by the already-placed block contents.
RectangleF | Frame`[get]`
| Gets the area where to place the block contents.
bool | Hyphenation`[get, set]`
| Gets/Sets whether the hyphenation algorithm has to be applied.
char | HyphenationCharacter`[get, set]`
| Gets/Sets the character shown at the end of the line before a hyphenation break.
LineAlignmentEnum | LineAlignment`[get, set]`
| Gets/Sets the default line alignment.
Length | LineSpace`[get, set]`
| Gets/Sets the text interline spacing.
ContentScanner | Scanner`[get]`
| Gets the content scanner.
XAlignmentEnum | XAlignment`[get]`
| Gets the horizontal alignment applied to the current content block.
YAlignmentEnum | YAlignment`[get]`
| Gets the vertical alignment applied to the current content block.

##

Content block composer.

It provides content positioning functionalities for page typesetting.

## Constructor & Destructor Documentation

org.pdfclown.documents.contents.composition.BlockComposer.BlockComposer | ( | PrimitiveComposer | baseComposer | ) |

References org.pdfclown.documents.contents.composition.PrimitiveComposer.Scanner.

## Member Function Documentation

void org.pdfclown.documents.contents.composition.BlockComposer.Begin | ( | RectangleF | frame,
|  | XAlignmentEnum | xAlignment,
|  | YAlignmentEnum | yAlignment |
| ) |  |  |

Begins a content block.

Parameters:

  | frame | Block boundaries.
  | xAlignment | Horizontal alignment.
  | yAlignment | Vertical alignment.

void org.pdfclown.documents.contents.composition.BlockComposer.End | ( |  | ) |

Ends the content block.

void org.pdfclown.documents.contents.composition.BlockComposer.ShowBreak | ( | SizeF | offset,
|  | XAlignmentEnum | xAlignment |
| ) |  |  |

Ends current paragraph, specifying the offset and alignment of the next one.

This functionality allows higher-level features such as paragraph indentation and margin.

Parameters:

  | offset | Relative location of the next paragraph.
  | xAlignment | Horizontal alignment.

void org.pdfclown.documents.contents.composition.BlockComposer.ShowBreak | ( | XAlignmentEnum | xAlignment | ) |

Ends current paragraph, specifying the alignment of the next one.

This functionality allows higher-level features such as paragraph indentation and margin.

Parameters:

  | xAlignment | Horizontal alignment.

void org.pdfclown.documents.contents.composition.BlockComposer.ShowBreak | ( | SizeF | offset | ) |

Ends current paragraph, specifying the offset of the next one.

This functionality allows higher-level features such as paragraph indentation and margin.

Parameters:

  | offset | Relative location of the next paragraph.

void org.pdfclown.documents.contents.composition.BlockComposer.ShowBreak | ( |  | ) |

Ends current paragraph.

int org.pdfclown.documents.contents.composition.BlockComposer.ShowText | ( | string | text,
|  | object | lineAlignment |
| ) |  |  |

Shows text.

Parameters:

  | text | Text to show.
  | lineAlignment | Line alignment. It can be: LineAlignmentEnum : arbitrary super-/sub-script, depending on whether the value is positive or not.

Returns:
  Last shown character index.

References org.pdfclown.documents.contents.composition.TextFitter.EndIndex, org.pdfclown.documents.contents.composition.TextFitter.Fit(), org.pdfclown.documents.contents.composition.TextFitter.FittedText, org.pdfclown.documents.contents.composition.TextFitter.FittedWidth, org.pdfclown.documents.contents.fonts.Font.GetAscent(), and org.pdfclown.documents.contents.fonts.Font.GetLineHeight().

int org.pdfclown.documents.contents.composition.BlockComposer.ShowText | ( | string | text | ) |

Shows text.

Default line alignment is applied.

Parameters:

  | text | Text to show.

Returns:
  Last shown character index.

References org.pdfclown.documents.contents.composition.BlockComposer.ShowText().

Referenced by org.pdfclown.documents.contents.composition.BlockComposer.ShowText().

bool org.pdfclown.documents.contents.composition.BlockComposer.ShowXObject | ( | xObjects::XObject | xObject,
|  | SizeF? | size,
|  | object | lineAlignment |
| ) |  |  |

Shows the specified external object.

Parameters:

  | xObject | External object.
  | size | Size of the external object.
  | lineAlignment | Line alignment. It can be: LineAlignmentEnum : arbitrary super-/sub-script, depending on whether the value is positive or not.

Returns:
  Whether the external object was successfully shown.

References org.pdfclown.documents.contents.xObjects.XObject.Size.

bool org.pdfclown.documents.contents.composition.BlockComposer.ShowXObject | ( | xObjects::XObject | xObject,
|  | SizeF? | size |
| ) |  |  |

Shows the specified external object.

Default line alignment is applied.

Parameters:

  | xObject | External object.
  | size | Size of the external object.

Returns:
  Whether the external object was successfully shown.

References org.pdfclown.documents.contents.composition.BlockComposer.ShowXObject().

Referenced by org.pdfclown.documents.contents.composition.BlockComposer.ShowXObject().

## Property Documentation

PrimitiveComposer org.pdfclown.documents.contents.composition.BlockComposer.BaseComposer`[get]`

Gets the base composer.

RectangleF org.pdfclown.documents.contents.composition.BlockComposer.BoundBox`[get]`

Gets the area occupied by the already-placed block contents.

RectangleF org.pdfclown.documents.contents.composition.BlockComposer.Frame`[get]`

Gets the area where to place the block contents.

bool org.pdfclown.documents.contents.composition.BlockComposer.Hyphenation`[get, set]`

Gets/Sets whether the hyphenation algorithm has to be applied.

Initial value:

    false

.

char org.pdfclown.documents.contents.composition.BlockComposer.HyphenationCharacter`[get, set]`

Gets/Sets the character shown at the end of the line before a hyphenation break.

Initial value: hyphen symbol (U+002D, i.e. '-').

LineAlignmentEnum org.pdfclown.documents.contents.composition.BlockComposer.LineAlignment`[get, set]`

Gets/Sets the default line alignment.

Initial value: LineAlignmentEnum.BaseLine.

Length org.pdfclown.documents.contents.composition.BlockComposer.LineSpace`[get, set]`

Gets/Sets the text interline spacing.

Initial value: 0.

ContentScanner org.pdfclown.documents.contents.composition.BlockComposer.Scanner`[get]`

Gets the content scanner.

XAlignmentEnum org.pdfclown.documents.contents.composition.BlockComposer.XAlignment`[get]`

Gets the horizontal alignment applied to the current content block.

YAlignmentEnum org.pdfclown.documents.contents.composition.BlockComposer.YAlignment`[get]`

Gets the vertical alignment applied to the current content block.

Copyright 2006-2013 Stefano Chizzolini. For more information, please visit PDF Clown home page.